/**
 * @file Processor.cpp
 * @author The ARTIS Development Team
 * See the AUTHORS or Authors.txt file
 */

/*
 * ARTIS - the multimodeling and simulation environment
 * This file is a part of the ARTIS environment
 *
 * Copyright (C) 2013-2023 ULCO http://www.univ-littoral.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "Processor.hpp"

namespace artis::factory {

  void Processor::dint(const Time & t) {
    switch (_phase) {
      case Phase::INIT: {
        _phase = Phase::WAIT;
        break;
      }
      case Phase::READY:
        _po.reset(nullptr);
        _phase = Phase::WAIT;
        break;
      case Phase::WAIT:
        assert(false);
        break;
      case Phase::LOADING: {
        _phase = Phase::PROCESSING;
        break;
      }
      case Phase::PROCESSING: {
        _phase = Phase::UNLOADING;
        break;
      }
      case Phase::UNLOADING: {
        _phase = Phase::READY;

#ifdef WITH_TRACE
        Trace::trace()
          << TraceElement(get_name(), t,
                          artis::common::FormalismType::PDEVS,
                          artis::common::FunctionType::DELTA_INT,
                          artis::common::LevelType::USER)
          << "FINISH po = " << _po->to_string();
        Trace::trace().flush();
#endif

        break;
      }
      default:
        assert(false);
    }
  }


  void Processor::dext(const Time &t, const Time & /* e */, const Bag &bag) {
  std::for_each(bag.begin(), bag.end(), [this, t](const ExternalEvent &event) {
    if (event.port_index() == inputs::IN) {
      uint8_t *data = nullptr;

    // TODO
      assert(_po == nullptr);

      event.data()(data);
      _po = std::make_unique<ProductionOrder>(data, event.data().size());
      _phase = Phase::LOADING;

#ifdef WITH_TRACE
      Trace::trace()
        << TraceElement(get_name(), t,
                        artis::common::FormalismType::PDEVS,
                        artis::common::FunctionType::DELTA_EXT,
                        artis::common::LevelType::USER)
        << "START po = " << _po->to_string();
      Trace::trace().flush();
#endif

    }
  });
}

void Processor::start(const Time & /* t */) {
  // TODO
  _phase = Phase::INIT;
}

Time Processor::ta(const Time & /* t */) const {
  // TODO
  switch (_phase) {
    case Phase::INIT:
    case Phase::READY:
      return 0;
    case Phase::WAIT:
      return artis::common::DoubleTime::infinity;
    case Phase::LOADING:
      return _parameters.load_time;
    case Phase::PROCESSING:
      return _parameters.processing_time;
    case Phase::UNLOADING:
      return _parameters.unload_time;
  }
  return artis::common::DoubleTime::infinity;
}

Bag Processor::lambda(const Time & /* t */) const {
  Bag bag;

  // TODO
  if (_phase == Phase::READY) {
    bag.push_back(ExternalEvent(outputs::OUT, common::event::Value(_po->_buffer, _po->_size)));
  }
  return bag;
}

artis::common::event::Value Processor::observe(const Time & /* t */, unsigned int /* index */) const {
  return {};
}

} // namespace artis::factory
